

#include <allegro.h>
#include <iostream>
#include <vector>
#include <sstream>
#include <math.h>
#include <list>
#include <map>
#include <fstream>
#include <stack>
#include <algorithm>
#include <queue>
#ifdef __APPLE__
#include <ApplicationServices/ApplicationServices.h>
#endif


using namespace std;


typedef double num;

int* bosshealth;
int bosshealthmax;

bool playlaser;
const int SPRITECOUNT=40;
const int SCREEN_HEIGHT=120;
const int SCREEN_WIDTH=160;
const unsigned int LEVELCOUNT=24;
int shootcount;
int oldshootcount;

int numhastargeted;
int endtimer;
int haswon;
bool bosslevel=false;

struct Pos {
	int x;
	int y;
};

const unsigned int MAXPARTS=8;
int targetcount[SPRITECOUNT];
Pos targets[SPRITECOUNT][MAXPARTS];
int levelstarttimer;
int TARGETCOUNT;

#include "craft.hpp"

const int BEAMLENGTH=60;

int magenta;
int red;
int black;
int white;
int green;
int blue;
int yellow;

const char* titles[LEVELCOUNT] =
{
"court",
"approach",
"indemnity",
"fascinate",
"pax",
"Horace",
"mine",
"sublimate",
"control",
"fasten",
"titer",
"Terence",
"xsyzl",
"vert",
"migraine",
"twilight",
"dusk",
"Francois",
"vespers",
"cancer",
"aubade",
"succour",
"salvage",
"Ali"
};

//used for targetting numerical enemies


BITMAP* buffer;
BITMAP* titlescreen;
BITMAP* levelbmp[LEVELCOUNT];
BITMAP* sprite[SPRITECOUNT];
BITMAP* bg;
BITMAP* lineoverlay;
BITMAP* explosionoverlay;


int t;
int spawntime;


struct EntityType {
	int health;
	bool overridey;
	Pos startpos;
	bool (*MoveFn)(Entity& ent);
	bool (*BeamFn)(int i);
	bool (*HitFn)(Entity& ent, int i);
};


const EntityType entitytypes[SPRITECOUNT] =
{
//0
{},
//1 boss 1 alwaysfiring either outside top or outside bottom, with all when it's in the centre of the screen
{30,false,(Pos){160,0},bossMove1,simpleBeam,basicHit},
//2 boss 2
{40,false,(Pos){160,0},bossMove2,simpleBeam,basicHit},
//3 boss 3
{400,false,(Pos){160,0},bossMove3,simpleBeam,bossHit3},
//4 boss 4
{20,false,(Pos){160,0},bossMove4,numTarget<5>,basicHit},
//5 ship1 - bomber, slow, fires big blasts rarely, moves strangely...
{4,false,(Pos){160,0},bomberMove,simpleBeam,basicHit},
//6 ship2 - moves slowly - explodes vertically
{1,false,(Pos){160,0},moveLeft<2>,simpleBeam,explodeVert},
//7ship3 - moves left in spurts; explodes horizontally [shoots as well :) ]
{1,false,(Pos){160,0},spurtLeft,simpleBeam,explodeHor},
//8ship4 - moves slowly; when explodes, fires bullets in eight directions.
{1,false,(Pos){160,0},slowMove<3>,simpleBeam,explodeBullets},
//9ship5 - moves quickly left
{1,false,(Pos){160,0},moveLeft<2>,simpleBeam,basicHit},
//10ship6 - moves quickly down, fires vertically down [have these appear at x=100, say?]
{1,true,(Pos){160,-10},moveDown<2>,simpleBeam,basicHit},
//11ship7 - moves quickly up, fires vertically up
{1,true,(Pos){160,130},moveUp<2>,simpleBeam,basicHit},
//12 number 1
{1,false,(Pos){160,0},moveLeft<1>,numTarget<1>,basicHit},
//13 number 2
{1,false,(Pos){160,0},moveLeft<1>,numTarget<2>,basicHit},
//14 number 3
{1,false,(Pos){160,0},moveLeft<1>,numTarget<3>,basicHit},
//15 number 4
{1,false,(Pos){160,0},moveLeft<1>,numTarget<4>,basicHit},
//16 ship 12 - moves in a sin wave, reasonably quick, fires small shots
{1,false,(Pos){160,0},sinMove<10>,simpleBeam,basicHit},
//17ship 13 - moves in diagonals, fires shots in bursts
{1,false,(Pos){160,0},zigzag<40>,simpleBeam,basicHit},
//18ship14  - moves ... ; fires pairs of small shots in bursts
{10,false,(Pos){160,0},pairFire<40>,simpleBeam,basicHit},
//19
{1,false,(Pos){160,0},moveLeft<1>,simpleBeam,explodeLeft},
//20
{1,false,(Pos){160,0},moveLeft<1>,simpleBeam,explodeDown},
//21
{1,false,(Pos){160,0},moveLeft<1>,simpleBeam,explodeUp},
//22
{1,false,(Pos){160,0},moveLeft<1>,simpleBeam,explodeRight},
//23
{1,false,(Pos){0,0},moveLeft<3>,noTarget,noHit},
//24
{1,false,(Pos){0,0},moveLeft<2>,noTarget,noHit},
//25
{1,false,(Pos){0,0},moveLeft<2>,simpleBeam,noHit},
//26
{},
//27
{},
//28
{},
//29 horizontal explosion
{1,false,(Pos){0,0},lifetime<30>,noTarget,noHit},
//30 vertical explosion
{1,false,(Pos){0,0},lifetime<30>,noTarget,noHit},
//31 boring bullet explosion
{},
//32 other explosion
{1,false,(Pos){0,0},lifetime<30>,noTarget,noHit},
};

Entity createentity(int CraftType, int health,
					bool (*MoveFn)(Entity& ent),
					bool (*BeamFn)(int i),
					bool (*HitFn)(Entity& ent, int i),
					Pos start);

Entity createentity(const EntityType& e, int image, int y)
{
	return createentity(image,
						e.health,
						e.MoveFn,
						e.BeamFn,
						e.HitFn,
						(Pos) {e.startpos.x,(e.overridey? e.startpos.y:y)});
}


struct E {
	Entity e;
	int t;
};

//add nice constructor for Entity taking an enum...

E levelentities[1000];
int levelentitycount=6;
int nextentity=0;


void addentity(int enemytype,int y, int onset)
{

	levelentities[levelentitycount]=(E){
createentity(entitytypes[enemytype],enemytype,y),
		onset
	};
	levelentitycount++;
}

const int MAPWIDTH=1000;
const int MAPHEIGHT=10;
void poplevel(BITMAP* bmp)
{
	levelentitycount=0;
	spawntime=0;
	for (int i=0;i<MAPWIDTH;i++)
	{
		for (int j=0;j<MAPHEIGHT;j++)
		{
			int p=getpixel(bmp,i,j);
			if (p!=black)
			{
				for (int k=0;k<SPRITECOUNT;k++)
				{
					if (p==colors[k])
					{
						addentity(k,j*120/10,i*120/10);
						break;
					}
				}
			}
		}
	}


	nextentity=0;

};

void spawnentity(int n, int y)
{

	entities[entitycount]=createentity(entitytypes[n],n,y);
	entitycount++;
}

void processmask(int n)
{
	for (int i=0;i<extents[n].x;i++)
		for (int j=0;j<extents[n].y;j++)
		{
			spritemask[n][i][j]=getpixel(sprite[n], i, j)!=magenta;
		}
}

#include "sound.hpp"
#include "misc.hpp"
#include "timer.hpp"

const int ts=13;
bool warover=false;
bool quit=false;
bool leave=false;
int titletimer=0;
bool finishedtitle;

bool escpressed;
bool apressed;

bool collided;

bool collides(int spritea, int spriteb, Pos& a, Pos& extentsa, Pos& b, Pos& extentsb)
{
	for (int i=max(a.x,b.x);i<min(a.x+extentsa.x,b.x+extentsb.x);i++)
	{
		for (int j=max(a.y,b.y);j<min(a.y+extentsa.y,b.y+extentsb.y);j++)
		{
			if (spritemask[spritea][i-a.x][j-a.y]
				&& spritemask[spriteb][i-b.x][j-b.y]
				)
			{
				return true;
			}
		}
	}
	return false;
}

bool showstory=false;

const char* storytext[7][2]=
{
{"There once was a",
"princess"},
{"with carnal",
"longings."},
{"To find the",
" most powerful men,"},
{"and to seduce them",
"with her wiles,"},
{"and to topple them.",
""},
{"She had a",
"space-ship"},
{"and bountiful",
"lust."},
};

const char* endtext[7][2]=
{
{"At her hands",
""},
{"all the great men",
"lay murdered."},
{"She thought",
"about them"},
{
"as she touched",
"herself"},
{"to amplify ",
"her pleasure."}
};


bool spacepressed;
int storyprogress;
bool finishedstory;
bool endmode;
int pauseafter;

class StoryLoop
	{
	public:
		static void initialize()
		{
			realshoot=false;
			spacepressed=true;
			storyprogress=0;
			finishedstory=false;
			pauseafter=0;
			playmusic(13);
		}
		static bool quitcondition()
		{
			return quit && pauseafter==0;
		}
		static void logic()
		{

			if (pauseafter>0)
				pauseafter--;

			if (key[KEY_ESC]&&!escpressed)
				quit=true;

			if (key[KEY_SPACE])
			{
				if (!spacepressed)
				{
					playsample(0);
					spacepressed=true;
					if (endmode)
					{
						if (storyprogress<4)
						{
							storyprogress++;
						}
						else
						{
							stopmusic();
							quit=true;
							pauseafter=30;
						}
					}
					else
					{
					if (storyprogress<6)
					{
						storyprogress++;
					}
					else
					{
						stopmusic();
						quit=true;
						pauseafter=30;
					}
					}
				}


			}
			else
			{
				spacepressed=false;
			}
		}
		static void draw()
		{
			clear_to_color(buffer, makecol(0,0,0));
			if (quit)
				return;

			if (endmode)
			{
				textout_centre_ex(buffer, font, endtext[storyprogress][0], 80, 50, makecol(255,255,255), makecol(0,0,0));
				textout_centre_ex(buffer, font, endtext[storyprogress][1], 80, 65, makecol(255,255,255), makecol(0,0,0));
			}
			else
			{
			textout_centre_ex(buffer, font, storytext[storyprogress][0], 80, 50, makecol(255,255,255), makecol(0,0,0));
			textout_centre_ex(buffer, font, storytext[storyprogress][1], 80, 65, makecol(255,255,255), makecol(0,0,0));
			}
		}
	};

class IntroLoop
	{
	public:
		static void initialize()
		{
			realshoot=false;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||warover||finishedtitle;
		}

		static void logic()
		{
			t=(t+2)%200;

			titletimer++;

			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}

		static void draw()
		{

			blit(bg,buffer,t,0,0,0,min(200-t,160),120);
			if (t>200-160)
				blit(bg,buffer,0,0, min(200-t,160),0,160-min(200-t,160),120);

			textout_ex(buffer, font, "increpare presents", 4, 50, makecol(100,100,100), -1);

		}
	};
int triggertext;

int endmenutimer;

class TitleLoop
	{
	private:
		static bool begin;
		static unsigned int selected;
		static bool upheld;
		static bool downheld;
		static bool spaceheld;
	public:
		static void initialize()
		{
			endmode=false;
			endmenutimer=0;
			realshoot=false;
			playmusic(5);
			begin=false;
			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;
			showstory=false;

		}

		static void logic()
		{
			t=(t+2)%200;

			if (endmenutimer>0)
			{
				endmenutimer--;

				if (endmenutimer==10)
					stopmusic();

				return;
			}

			if (key[KEY_ESC]&&!escpressed)
				quit=true;
			escpressed=key[KEY_ESC];


			triggertext=(triggertext+5) % 255;

			if (key[KEY_UP])
			{
				if (!upheld)
				{
					selected=(selected+2)%3;
					playsample(1);
					upheld=true;
				}
			}
			else
				upheld=false;

			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					selected=(selected+1)%3;
					playsample(1);
					downheld=true;
				}
			}
			else
				downheld=false;

			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					if (selected==0)
					{
						begin=true;
						endmenutimer=40;
						playsample(0);
					}
					else if (selected==1)
					{
						begin=true;
						endmenutimer=40;
						playsample(0);
						showstory=true;
					}
					else
					{
						quit=true;
						playsample(0);
						endmenutimer=40;
					}
				}
			}
			else
				spaceheld=false;

		}

		static bool quitcondition()
		{
			return (quit||begin) && endmenutimer==0;
		}

		static void draw()
		{

			blit(bg,buffer,t,0,0,0,min(200-t,160),120);
			if (t>200-160)
				blit(bg,buffer,0,0, min(200-t,160),0,160-min(200-t,160),120);

			if ( (endmenutimer>0 && endmenutimer<10))
			{
				return;
			}

			masked_blit(titlescreen,buffer,0,0,0,0,160,120);
//			textout_ex(buffer,font,"TRIGGER",8,7,makecol(triggertext,triggertext,triggertext),makecol(0,0,0));
			if (selected==0)
			{
				if (endmenutimer%2==0)
				textout_ex(buffer,font,"START",100,60,makecol(100,100,100),makecol(255,255,255));
				textout_ex(buffer,font,"Story",100,72,makecol(255,255,255),-1);
				textout_ex(buffer,font,"Exit",100,84,makecol(255,255,255),-1);
			}
			else if (selected==1)
			{
				textout_ex(buffer,font,"Start",100,60,makecol(255,255,255),-1);

				if (endmenutimer%2==0)
				textout_ex(buffer,font,"STORY",100,72,makecol(100,100,100),makecol(255,255,255));
				textout_ex(buffer,font,"Exit",100,84,makecol(255,255,255),-1);
			}
			else
			{
				textout_ex(buffer,font,"Start",100,60,makecol(255,255,255),-1);
				textout_ex(buffer,font,"Story",100,72,makecol(255,255,255),-1);

				if (endmenutimer%2==0)
				textout_ex(buffer,font,"EXIT",100,84,makecol(100,100,100),makecol(255,255,255));
			}

		}

	};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;

unsigned int levelmax=0;

int scol(unsigned int n)
{
	if (n<=levelmax)
	{
		if (n%6==5)
			return makecol(255,255,100);
		else
			return makecol(255,255,255);
	}
	else
		return makecol(20,20,20);
}


class SelectLoop
	{
	private:
		static bool begin;
		static bool upheld;
		static bool downheld;
		static bool spaceheld;
	public:
		static unsigned int selected;
		static void initialize()
		{
			endmenutimer=0;
			realshoot=false;
			begin=false;
			//			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;
			leave=false;
			playmusic(12);

		}

		static void logic()
		{
			t=(t+2)%200;

			if (endmenutimer>0)
			{
				endmenutimer--;
				if (endmenutimer==30)
					stopmusic();
				return;
			}

			if (key[KEY_ESC]&&!escpressed)
				quit=true;
			escpressed=key[KEY_ESC];

			triggertext=(triggertext+5) % 255;

			if (key[KEY_UP])
			{
				if (!upheld)
				{
					selected=(selected-1+levelmax+1)%(levelmax+1);
					if (levelmax!=0)
						playsample(1);
					upheld=true;
				}
			}
			else
				upheld=false;

			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					selected=(selected+1)%(levelmax+1);
					if (levelmax!=0)
						playsample(1);
					upheld=true;
					downheld=true;
				}
			}
			else
				downheld=false;

			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					playsample(0);
					endmenutimer=60;
					leave=true;
				}
			}
			else
				spaceheld=false;

		}

		static bool quitcondition()
		{
			return (quit||leave||warover) && endmenutimer==0;
		}

		static void draw()
		{

			clear_to_color(buffer,makecol(0,0,0));

			if ( (endmenutimer>0 && endmenutimer<30) )
			{
				return;
			}

			blit(bg,buffer,t,0,0,0,min(200-t,160),120);
			if (t>200-160)
				blit(bg,buffer,0,0, min(200-t,160),0,160-min(200-t,160),120);


			textout_ex(buffer,font,"TRIGGER",8,7,makecol(triggertext,triggertext,triggertext),-1);

			for (unsigned int i=1;i<3;i++)
			{
				if (selected>=i)
					textout_ex(buffer,font,titles[selected-i],54,40-10*i,scol(selected-i),-1);
			}

			if (endmenutimer%2==0)
			textout_ex(buffer,font,titles[selected],54,40,
					   makecol(255,10,10)
					   ,-1);

			for (unsigned int i=1;i<9;i++)
			{
				if (selected<(LEVELCOUNT-i))
						textout_ex(buffer,font,titles[selected+i],54,40+10*i,scol(selected+i),-1);
			}

		}

	};

bool SelectLoop::begin=false;
unsigned int SelectLoop::selected=0;
bool SelectLoop::upheld=false;
bool SelectLoop::downheld=false;
bool SelectLoop::spaceheld=true;



bool pressed[5];
unsigned int curselected;
enum GameState {
	gs_selecting,
	gs_weather,
	gs_action
} gamestate;

string displaystring;
int turn;
const int maxturn=8;

//targets based on type
Entity createentity(int CraftType, int health,
					bool (*MoveFn)(Entity& ent),
					bool (*BeamFn)(int i),
					bool (*HitFn)(Entity& ent, int i),
					Pos pos)
{
	Entity e;
	e.pos=pos;
	e.health=health;
	for (unsigned int i=0;i<MAXPARTS;i++)
	{
		e.targeted[i]=0;
	}

	e.image=CraftType;

	e.extents=extents[CraftType];
	e.doMove=MoveFn;
	e.canTarget=BeamFn;
	e.onHit=HitFn;

	e.movepar=0;

	return e;

}




const int MAXVEL=3;

void maketargets()
{
	bool targetmade=false;

	if (apressed)
	{
		TARGETCOUNT=0;
		for (int i=0;i<entitycount;i++)
		{
			if (entities[i].pos.x>=player.pos.x)
			{
				for (int j=0;j<targetcount[entities[i].image];j++)
				{
					if (!entities[i].targeted[j] )
					{
						if (abs(player.pos.y+4-(entities[i].pos.y+targets[entities[i].image][j].y))<2
							&& (entities[i].pos.x+targets[entities[i].image][j].x<160)
							&& (entities[i].pos.x+targets[entities[i].image][j].x<player.pos.x+9+BEAMLENGTH)
							&& entities[i].canTarget(j))
						{
							entities[i].targeted[j]=true;
							targetmade=true;
						}
					}
					else
					{
						TARGETCOUNT++;
					}
				}
			}
		}

		if (targetmade)
		{
			clear_to_color(lineoverlay,magenta);
			for (int i=0;i<entitycount;i++)
			{
				for (int j=0;j<targetcount[entities[i].image];j++)
				{
					if (entities[i].targeted[j])
					{
						fastline(lineoverlay, player.pos.x+9, player.pos.y+4,entities[i].pos.x+targets[entities[i].image][j].x ,entities[i].pos.y+targets[entities[i].image][j].y, makecol(0,255,0));
					}
				}
			}
			shoottimer=5;
			realshoot=false;
			playsample(6,(1000*(5+TARGETCOUNT))/5);
		}
	}

}

int shipnumber(int n)
{
	switch (n)
	{
		case 1 ... 4:
			return 11+n;
			break;
		case 5:
			return 4;
			break;
	}
	return 0;
}

bool isnumbered(int n)
{
	return (n>=12 && n<=15); // highest number doesn't matter ->  || n==4;
}

void recalcnumbers()
{
	//have to go through up to four times
	int n;
	for (n=1;n<=5;n++)
	{
		int shipno=shipnumber(n);
		bool foundship=false;;
		//draw enemies
		for (int i=0;i<entitycount;++i)
		{
			for (int j=0;j<targetcount[entities[i].image];j++)
			{
				if (entities[i].image==shipno && entities[i].targeted[j])
				{
					foundship=true;
					break;
				}
			}
			if (foundship)
				break;
		}
		if (!foundship)
			break;
	}

	//deselect remaining;
	for (;n<=5;n++)
	{
		int shipno=shipnumber(n);

		for (int i=0;i<entitycount;++i)
		{
			for (int j=0;j<targetcount[entities[i].image];j++)
			{
				if (entities[i].image==shipno && entities[i].targeted[j])
				{
					entities[i].targeted[j]=false;
				}
			}
		}

	}
}

void savedat();
void loaddat();

void winlevel()
{
	if (endtimer>0)
		return;

	endtimer=120;
	haswon=true;
	playmusic(6);

	if (SelectLoop::selected==levelmax && levelmax<LEVELCOUNT-1)
	{
		SelectLoop::selected++;
		levelmax++;
		savedat();
	}
	else if (SelectLoop::selected==levelmax)
	{

		endmode=true;
		//??game over screen?
	}
}

void loselevel()
{
	stopmusic();
	haswon=false;
	endtimer=120;
}

void removeentity(int i)
{
	bool isboss = entities[i].image<=4;

	swap(entities[i],entities[entitycount-1]);
	for (int j=0;j<removecount;j++)
	{
		if (toremove[j]==entitycount-1)
		{
			toremove[j]=i;
			break;
		}
	}
	entitycount--;
	if ((entitycount==0 && nextentity==levelentitycount) || isboss)
	{
		winlevel();
	}
}

template<int bullet>
void shootfrom(Pos p)
{
	if (bullet>4)
    {
        entities[entitycount] =  createentity(23+bullet,1,lifetime<20>,noTarget,noHit,p);
        entitycount++;
		playsample(7+rand()%2);
    }
    else
    {
        entities[entitycount] =  createentity(23+bullet,1,moveLeft<2>,noTarget,noHit,p);
        entitycount++;
		playlaser=true;
    }

}

void explodefrom(Pos p)
{


	entities[entitycount] = createentity(24, 1,
							   moveDir<0>,
							   noTarget,
							   noHit,
							   p);
	entitycount++;

	entities[entitycount] = createentity(24, 1,
							   moveDir<1>,
										 noTarget,
										 noHit,
							   p);
	entitycount++;

	entities[entitycount] = createentity(24, 1,
							   moveDir<2>,
										 noTarget,
										 noHit,
							   p);
	entitycount++;

	entities[entitycount] = createentity(24, 1,
							   moveDir<3>,
										 noTarget,
										 noHit,
							   p);
	entitycount++;

	entities[entitycount] = createentity(24, 1,
							   moveDir<4>,
										 noTarget,
										 noHit,
							   p);
	entitycount++;

	entities[entitycount] = createentity(24, 1,
							   moveDir<5>,
										 noTarget,
										 noHit,
							   p);
	entitycount++;

	entities[entitycount] = createentity(24, 1,
							   moveDir<6>,
										 noTarget,
										 noHit,
							   p);
	entitycount++;

	entities[entitycount] = createentity(24, 1,
							   moveDir<7>,
										 noTarget,
										 noHit,
							   p);
	entitycount++;



}


void LineExplodeH(int y)
{
	entities[entitycount] = createentity(27, 1,
							   flashfor<10>,
										 noTarget,
										 noHit,
							   (Pos){0,y});
	entitycount++;
}

int targettimer;


template<int n>
class GameLoop
	{
	public:

		static void initialize()
		{
			TARGETCOUNT=0;
			endmode=false;
			levelstarttimer=60;
			bosslevel=n%6==5;
			shoottimer=0;
			realshoot=false;
			nextentity=0;
			shootcount=0;

			if (n%6==5)
				playmusic((n-5)/6);
			else
				playmusic(7+n%6);//add another track?
			t=0;
			player.pos.x=10;
			player.pos.y=SCREEN_HEIGHT/2;
			player.vel.x=0;
			player.vel.y=0;
			player.extents.x=extents[0].x;
			player.extents.y=extents[0].y;

			warover=false;
			leave=false;
			endtimer=0;

			escpressed=true;
			apressed=false;
			numhastargeted=0;
			entitycount=0;
			poplevel(levelbmp[n]);

			if (bosslevel)
			{
				bosshealthmax=levelentities[0].e.health;
				bosshealth=&levelentities[0].e.health;
			}

/*			for (int i=0;i<10;i++)
			{
				entities[entitycount]=
							   createentity((Pos){rand()%160,rand()%SCREEN_HEIGHT}, 14, 5,
											(rand()%2==0 ?staticMove:Move2),
											simpleBeam);
				entitycount++;
			}*/


		}

		static bool quitcondition()
		{
			return quit||leave||warover;
		}

		static void logic()
		{
			playlaser=false;
			t=(t+4)%200;

			if (endtimer>0)
			{
				endtimer--;
				if (endtimer==0)
					leave=true;
				if (endtimer==60)
					stopmusic();
				return;
			}

			if (levelstarttimer>0)
				levelstarttimer--;

			targettimer=(targettimer+1)%32;

			spawntime++;

			while (nextentity<levelentitycount && levelentities[nextentity].t<=spawntime)
			{
				entities[entitycount]=levelentities[nextentity].e;
				if (bosslevel)
				{
					bosshealth=&entities[entitycount].health;
				}
				nextentity++;
				entitycount++;
			}


			if (shoottimer>0)
				shoottimer--;


			if (key[KEY_ESC]&&!escpressed)
				leave=true;

			if (key[KEY_A]&&!apressed)
			{
				apressed=true;
				playsample(11);
			}
			else if (!key[KEY_A]&&apressed)
			{
				apressed=false;
				playsample(11);

				//FIRE!
				shootcount=0;
				clear_to_color(lineoverlay,magenta);
				for (int i=0;i<entitycount;i++)
				{
					for (int j=0;j<targetcount[entities[i].image];j++)
					{
						if (entities[i].targeted[j])
						{
							targeted[shootcount]=(Pos){i,j};
							shootcount++;
							entities[i].targeted[j]=0;
							fastline(lineoverlay, player.pos.x+9, player.pos.y+4,entities[i].pos.x+targets[entities[i].image][j].x ,entities[i].pos.y+targets[entities[i].image][j].y, makecol(0,0,255));
						}
					}
				}

				if (shootcount>0)
				{
					removecount=0;

					for (int i=0;i<shootcount;i++)
					{
						if (entities[targeted[i].x].onHit(entities[targeted[i].x],targeted[i].y))
						{
							bool alreadyonlist=false;
							for (int j=0;j<removecount;j++)
							{
								if (toremove[j]==targeted[i].x)
								{
									alreadyonlist=true;
									break;
								}
							}
							if (!alreadyonlist)
							{
								masked_blit(sprite[31], lineoverlay,
									 0,0,
									 entities[targeted[i].x].pos.x+entities[targeted[i].x].extents.x/2-extents[31].x/2,
									 entities[targeted[i].x].pos.y+entities[targeted[i].y].extents.y/2-extents[31].y/2,
									 extents[31].x,extents[31].y
									 );


								toremove[removecount]=targeted[i].x;
								removecount++;
							}

						}
					}

					oldshootcount=shootcount;
					shootcount=0;
					numhastargeted=0;

					for (int i=0;i<removecount;i++)
					{
						removeentity(toremove[i]);
					}

					if (removecount>0)
					{
						playsample(4);
					}
					else
					{
						playsample(5);
					}

					shoottimer=10;
					realshoot=true;
				}

			}

			maketargets();
			escpressed=key[KEY_ESC];



			if (key[KEY_UP]&&!key[KEY_DOWN])
			{
				if (player.vel.y>-MAXVEL)
					player.vel.y--;
			}
			else if (key[KEY_DOWN]&&!key[KEY_UP])
			{
				if (player.vel.y<MAXVEL)
					player.vel.y++;
			}
			else
			{
				if (player.vel.y<0)
				{
					player.vel.y++;
				}
				else if (player.vel.y>0)
				{
					player.vel.y--;
				}
			}

			if (key[KEY_LEFT]&&!key[KEY_RIGHT])
			{
				if (player.vel.x>-MAXVEL)
					player.vel.x--;
			}
			else if (key[KEY_RIGHT]&&!key[KEY_LEFT])
			{
				if (player.vel.x<MAXVEL)
					player.vel.x++;
			}
			else
			{
				if (player.vel.x<0)
				{
					player.vel.x++;
				}
				else if (player.vel.x>0)
				{
					player.vel.x--;
				}
			}


			//move player
			if (player.vel.x<0)
			{
				if (player.pos.x+player.vel.x>=0)
					player.pos.x+=player.vel.x;
				else
					player.pos.x=0;
			}
			else if (player.vel.x)
			{
				if (player.pos.x+player.vel.x<SCREEN_WIDTH-player.extents.x)
					player.pos.x+=player.vel.x;
				else
					player.pos.x=SCREEN_WIDTH-player.extents.x;
			}

			if (player.vel.y<0)
			{
				if (player.pos.y+player.vel.y>=0)
					player.pos.y+=player.vel.y;
				else
					player.pos.y=0;
			}
			else if (player.vel.y)
			{
				if (player.pos.y+player.vel.y<SCREEN_HEIGHT-player.extents.y)
					player.pos.y+=player.vel.y;
				else
					player.pos.y=SCREEN_HEIGHT-player.extents.y;
			}

			maketargets();


			//move ships
			removecount=0;
			bool shouldrecalcnumbers=false;

			for (int i=0;i<entitycount;++i)
			{
				if (entities[i].doMove(entities[i]))
				{
					if (!bosslevel && entities[i].image>4 && entities[i].image<=21)
					{
						loselevel();
						playsample(2);
					}
			/*
			 obnoxious exploding
			 if (entities[i].image<22)
					{
						exploderfrom((Pos){entities[i].pos.x+entities[i].extents.x/2,entities[i].pos.y+entities[i].extents.y/2});
					}
			*/
					toremove[removecount]=i;
					removecount++;
					if (isnumbered(entities[i].image))
						shouldrecalcnumbers=true;
				}
			}

			for (int i=0;i<removecount;i++)
			{
				removeentity(toremove[i]);
			}

			maketargets();

			if (shouldrecalcnumbers)
				recalcnumbers();

			//check for collisions
			collided=false;
			for (int i=0;i<entitycount;++i)
			{
				if (collides(0,entities[i].image,player.pos,player.extents,entities[i].pos,entities[i].extents))
				{
					collided=true;
					loselevel();
					playsample(2);
					clear_to_color(lineoverlay,magenta);
					masked_blit(sprite[31], lineoverlay,
								0,0,
								player.pos.x+player.extents.x/2-extents[31].x/2,
								player.pos.y+player.extents.y/2-extents[31].y/2,
								extents[31].x,extents[31].y
								);
					oldshootcount=20;
					realshoot=true;
					shoottimer=10;
					break;
				}
			}

			if (playlaser)
				playsample(9);


		}

		static void draw()
		{


			//clear_to_color(buffer, black);
			blit(bg,buffer,t,0,0,0,min(200-t,160),120);
			if (t>200-160)
				blit(bg,buffer,0,0, min(200-t,160),0,160-min(200-t,160),120);



			if (endtimer>60 && endtimer<90)
			{
				if (haswon)
				{
					textout_centre_ex(buffer, font, "victory!", 80, 55, makecol(255,255,255), makecol(0,0,0));

				}
				else
				{
					textout_centre_ex(buffer, font, "failure", 80, 55, makecol(0,255,0), makecol(0,0,0));
				}
			}
			else if (endtimer>0 && endtimer<61)
			{
				clear_to_color(buffer, makecol(0,0,0));
				return;
			}


			int numenemiestargeted=0;

					int targetimage = (targettimer/16 == 0 ? 27 : 28 );

				//draw enemies
				for (int i=0;i<entitycount;++i)
				{
					masked_blit(sprite[entities[i].image],buffer,0,0,entities[i].pos.x,entities[i].pos.y,entities[i].extents.x,entities[i].extents.y);
					for (int j=0;j<targetcount[entities[i].image];j++)
					{
						if (entities[i].targeted[j])
						{
							numenemiestargeted++;
							masked_blit(sprite[targetimage],buffer,0,0,entities[i].pos.x+targets[entities[i].image][j].x-2,entities[i].pos.y+targets[entities[i].image][j].y-2,5,5);
						}
					}
				}

			if (apressed && endtimer==0)
			{
			//draw beam
				if (numenemiestargeted<3)
					hline(buffer, player.pos.x+player.extents.x, player.pos.y+4, min(player.pos.x+player.extents.x+BEAMLENGTH,SCREEN_WIDTH-1), makecol(100,100,0));
				else if (numenemiestargeted<5)
					hline(buffer, player.pos.x+player.extents.x, player.pos.y+4, min(player.pos.x+player.extents.x+BEAMLENGTH,SCREEN_WIDTH-1), makecol(255,255,0));
				else
					hline(buffer, player.pos.x+player.extents.x, player.pos.y+4, min(player.pos.x+player.extents.x+BEAMLENGTH,SCREEN_WIDTH-1), makecol(255,255,200));

			}
//				masked_blit(sprite[26],buffer,0,0,player.pos.x+player.extents.x,player.pos.y+4,SCREEN_WIDTH-player.pos.x-player.extents.x,1);


			if (!collided)
				masked_blit(sprite[0], buffer,0,0, player.pos.x, player.pos.y,  player.extents.x, player.extents.y);

			if (shoottimer>0 && shoottimer%2==0)
			{
					masked_blit(lineoverlay, buffer, 0, 0, 0, 0, 160, 120);
			}

			if (levelstarttimer>0 && (levelstarttimer/10 % 2 !=0))
			{
				if (bosslevel)
					textout_centre_ex(buffer, font, "kill the boss!", 80, 55, makecol(0,255,0), -1);
				else
					textout_centre_ex(buffer, font, "destroy all enemies!", 80, 55, makecol(0,255,0), -1);
			}


			if (bosslevel&&endtimer==0)
				rectfill(buffer, 10, 1, 10+(*bosshealth *(160-20))/bosshealthmax, 4, red);
		}

	};

template<class T>
void loop()
{

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			//			if (key[KEY_ESC])
			//				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();

		if (realshoot&&shoottimer>0&&oldshootcount>0)
		{
			int r1=rand()%oldshootcount;
			int r2=rand()%oldshootcount;
			int r3=rand()%oldshootcount;
			int r4=rand()%oldshootcount;

			if (collided&&endtimer>60)
			{
				for (int i=0;i<400;i++)
					putpixel(buffer, rand()%160, rand()%120, makecol(0,255,0));
			}

			stretch_blit(buffer, screen, r1, r2, 160-r1, 120-r2, 0, 0, 640-4*r3, 480-4*r4);
		}
		else
		{
			stretch_blit(buffer, screen, 0, 0, 160, 120, 0, 0, 640, 480);

		}

	}
}


void loaddat()
{

	ifstream file;
	file.open("savedat.bin");
	if(file){
		file >> levelmax;
		levelmax ^= 1234123; //decrypt
	}
	else
	{
		levelmax=0;
	}
	file.close();
 }

void savedat()
{
	ofstream file;
	file.open("savedat.bin", ios::trunc);
	file << (levelmax ^ 1234123);//encrypt
	file.close();
}
void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	#ifdef __APPLE__
	CGDisplayHideCursor(kCGDirectMainDisplay);
	#endif


	loaddat();


	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(45));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;

	red=makecol(255,0,0);
	magenta=makecol(255,0,255);
	black=makecol(0,0,0);
	white=makecol(255,255,255);
	blue=makecol(0,0,255);
	yellow=makecol(255,255,0);
	green=makecol(0,255,0);

	//load save data


	//init the buffer
	buffer=create_bitmap(160,120);

	lineoverlay=create_bitmap(160,120);
	clear_to_color(lineoverlay, magenta);


	bg=load_bmp("bmp/bg.bmp",NULL);
	titlescreen=load_bmp("bmp/titlescreen.bmp",NULL);

	for (unsigned int i=0;i<LEVELCOUNT;i++)
	{
		stringstream s;
		s<<"bmp/stage"<< i <<".bmp";

		levelbmp[i]=load_bmp(s.str().c_str(), NULL);

	}


	int i=0;
	//load sprite bitmap

	//player - 9x9
	sprite[i]=load_bmp("bmp/player.bmp", NULL);
	extents[i].x=9;
	extents[i].y=9;
	targetcount[i]=1;
	targets[i][0]=(Pos){0,0};
	processmask(i);
	i++;

	//boss1 - 25x30
	sprite[i]=load_bmp("bmp/boss1.bmp", NULL);
	colors[i]=makecol(230,230,230);
	extents[i].x=25;
	extents[i].y=30;
	targetcount[i]=2;
	targets[i][0]=(Pos){9,5};
	targets[i][1]=(Pos){9,24};
	processmask(i);
	i++;


	//boss2 - 8x20
	sprite[i]=load_bmp("bmp/boss2.bmp", NULL);
	colors[i]=makecol(240,240,240);
	extents[i].x=8;
	extents[i].y=20;
	targetcount[i]=1;
	targets[i][0]=(Pos){4,9};
	processmask(i);
	i++;


	//boss3 - 26x37
	sprite[i]=load_bmp("bmp/boss3.bmp", NULL);
	colors[i]=makecol(250,250,250);
	extents[i].x=26;
	extents[i].y=37;
	targetcount[i]=6;
	targets[i][0]=(Pos){21,1};
	targets[i][1]=(Pos){16,4};
	targets[i][2]=(Pos){7,10};
	targets[i][3]=(Pos){7,26};
	targets[i][4]=(Pos){16,32};
	targets[i][5]=(Pos){21,35};
	processmask(i);
	i++;


	//boss4 23x23
	sprite[i]=load_bmp("bmp/boss4.bmp", NULL);
	colors[i]=makecol(255,255,255);
	extents[i].x=23;
	extents[i].y=23;
	targetcount[i]=1;
	targets[i][0]=(Pos){11,11};
	processmask(i);
	i++;


	//ship1 - 18x19
	sprite[i]=load_bmp("bmp/ship1.bmp", NULL);
	extents[i].x=18;
	extents[i].y=19;
	targetcount[i]=1;
	colors[i]=makecol(128,128,0);
	targets[i][0]=(Pos){5,9};
	processmask(i);
	i++;


	//ship2 - 5x15
	sprite[i]=load_bmp("bmp/ship2.bmp", NULL);
	extents[i].x=5;
	extents[i].y=15;
	targetcount[i]=2;
	colors[i]=makecol(255,0,255);
	targets[i][0]=(Pos){2,2};
	targets[i][1]=(Pos){2,12};
	processmask(i);
	i++;


	//ship3 - 20x7
	sprite[i]=load_bmp("bmp/ship3.bmp", NULL);
	extents[i].x=20;
	extents[i].y=7;
	targetcount[i]=1;
	colors[i]=makecol(127,0,127);
	targets[i][0]=(Pos){2,3};
	processmask(i);
	i++;


	//ship4 - 5x8
	sprite[i]=load_bmp("bmp/ship4.bmp", NULL);
	extents[i].x=5;
	extents[i].y=8;
	targetcount[i]=1;
	colors[i]=makecol(102,102,102);
	targets[i][0]=(Pos){2,1};
	processmask(i);
	i++;


	//ship5 - 9x5
	sprite[i]=load_bmp("bmp/ship5.bmp", NULL);
	extents[i].x=9;
	extents[i].y=5;
	targetcount[i]=1;
	colors[i]=makecol(0,127,127);
	targets[i][0]=(Pos){0,2};
	processmask(i);
	i++;


	//#10
	//ship6 - 5x7
	sprite[i]=load_bmp("bmp/ship6.bmp", NULL);
	extents[i].x=5;
	extents[i].y=7;
	targetcount[i]=1;
	colors[i]=makecol(0,0,127);
	targets[i][0]=(Pos){3,6};
	processmask(i);
	i++;


	//ship7 - 5x7
	sprite[i]=load_bmp("bmp/ship7.bmp", NULL);
	extents[i].x=5;
	extents[i].y=7;
	targetcount[i]=1;
	colors[i]=makecol(255,255,0);
	targets[i][0]=(Pos){3,0};
	processmask(i);
	i++;


	//ship8 - 5x5
	sprite[i]=load_bmp("bmp/ship8.bmp", NULL);
	extents[i].x=5;
	extents[i].y=5;
	targetcount[i]=1;
	colors[i]=makecol(255,0,0);
	targets[i][0]=(Pos){2,2};
	processmask(i);
	i++;


	//ship9 - 5x7
	sprite[i]=load_bmp("bmp/ship9.bmp", NULL);
	extents[i].x=5;
	extents[i].y=7;
	targetcount[i]=1;
	colors[i]=makecol(200,0,0);
	targets[i][0]=(Pos){2,3};
	processmask(i);
	i++;


	//ship10 - 9x7
	sprite[i]=load_bmp("bmp/ship10.bmp", NULL);
	extents[i].x=9;
	extents[i].y=7;
	targetcount[i]=1;
	colors[i]=makecol(150,0,0);
	targets[i][0]=(Pos){4,3};
	processmask(i);
	i++;

	//ship11 - 9x9
	sprite[i]=load_bmp("bmp/ship11.bmp", NULL);
	extents[i].x=9;
	extents[i].y=9;
	targetcount[i]=1;
	colors[i]=makecol(100,0,0);
	targets[i][0]=(Pos){4,4};
	processmask(i);
	i++;


	//ship12 - 5x6
	sprite[i]=load_bmp("bmp/ship12.bmp", NULL);
	extents[i].x=5;
	extents[i].y=6;
	targetcount[i]=1;
	colors[i]=makecol(0,0,255);
	targets[i][0]=(Pos){2,2};
	processmask(i);
	i++;


	//ship 13 - 8x7
	sprite[i]=load_bmp("bmp/ship13.bmp", NULL);
	extents[i].x=8;
	extents[i].y=7;
	targetcount[i]=1;
	colors[i]=makecol(0,255,255);
	targets[i][0]=(Pos){6,3};
	processmask(i);
	i++;


	//ship 14 - 12x15
	sprite[i]=load_bmp("bmp/ship14.bmp", NULL);
	extents[i].x=12;
	extents[i].y=15;
	targetcount[i]=2;
	colors[i]=makecol(51,51,51);
	targets[i][0]=(Pos){6,5};
	targets[i][1]=(Pos){6,9};
	processmask(i);
	i++;


	//ship 15 - 11x7
	sprite[i]=load_bmp("bmp/ship15.bmp", NULL);
	extents[i].x=11;
	extents[i].y=7;
	targetcount[i]=1;
	colors[i]=makecol(0,255,0);
	targets[i][0]=(Pos){5,3};
	processmask(i);
	i++;


	//ship 16 - 9x9
	sprite[i]=load_bmp("bmp/ship16.bmp", NULL);
	extents[i].x=9;
	extents[i].y=9;
	targetcount[i]=1;
	colors[i]=makecol(0,200,0);
	targets[i][0]=(Pos){3,3};
	processmask(i);
	i++;

	//#20
	//ship 17 - 9x9
	sprite[i]=load_bmp("bmp/ship17.bmp", NULL);
	extents[i].x=9;
	extents[i].y=9;
	targetcount[i]=1;
	colors[i]=makecol(0,150,0);
	targets[i][0]=(Pos){3,5};
	processmask(i);
	i++;


	//ship 18 - 11x9
	sprite[i]=load_bmp("bmp/ship18.bmp", NULL);
	extents[i].x=11;
	extents[i].y=9;
	targetcount[i]=1;
	colors[i]=makecol(0,100,0);
	targets[i][0]=(Pos){3,4};
	processmask(i);
	i++;

	//bullet1 - 4x1
	sprite[i]=load_bmp("bmp/bullet1.bmp", NULL);
	extents[i].x=4;
	extents[i].y=1;
	targetcount[i]=1;
	targets[i][0]=(Pos){0,0};
	processmask(i);
	i++;


	//bullet2 - 3x3
	sprite[i]=load_bmp("bmp/bullet2.bmp", NULL);
	extents[i].x=3;
	extents[i].y=3;
	targetcount[i]=1;
	targets[i][0]=(Pos){0,0};
	processmask(i);
	i++;


	//bullet3 - 4x4
	sprite[i]=load_bmp("bmp/bullet3.bmp", NULL);
	extents[i].x=4;
	extents[i].y=4;
	targetcount[i]=1;
	targets[i][0]=(Pos){0,0};
	processmask(i);
	i++;


	//bullet4 - 1x1
	sprite[i]=load_bmp("bmp/bullet4.bmp", NULL);
	extents[i].x=1;
	extents[i].y=1;
	targetcount[i]=1;
	targets[i][0]=(Pos){0,0};
	processmask(i);
	i++;

	//#26
	//target1 - 160x2
	sprite[i]=load_bmp("bmp/target1.bmp", NULL);
	extents[i].x=5;
	extents[i].y=5;
	targetcount[i]=0;
	processmask(i);
	i++;

	//target2 - 5x5
	sprite[i]=load_bmp("bmp/target2.bmp", NULL);
	extents[i].x=5;
	extents[i].y=5;
	targetcount[i]=0;
	processmask(i);
	i++;

	//horizontal explosion - 160x7
	sprite[i]=load_bmp("bmp/horexplode.bmp", NULL);
	extents[i].x=160;
	extents[i].y=7;
	targetcount[i]=0;
	processmask(i);
	i++;

	//vertical explosion - 3x120
	sprite[i]=load_bmp("bmp/verexplode.bmp", NULL);
	extents[i].x=3;
	extents[i].y=120;
	targetcount[i]=0;
	processmask(i);
	i++;

	//#30
	//normal explosion 18x18
	sprite[i]=load_bmp("bmp/explosion.bmp", NULL);
	extents[i].x=18;
	extents[i].y=18;
	targetcount[i]=0;
	processmask(i);
	i++;


	//bullet5 - 160x120
	sprite[i]=load_bmp("bmp/bullet5.bmp", NULL);
	extents[i].x=160;
	extents[i].y=120;
	targetcount[i]=0;
	processmask(i);
	i++;


}

int dir;
int px;
int py;

int main(int argc, char *argv[])
{

	init();


	loop<IntroLoop>();

titletag:

	loop<TitleLoop>();

storytag:
	if (showstory)
	{
		loop<StoryLoop>();
		quit=false;
		playmusic(14);
		goto titletag;
	}
	else
	{
	while (!quit)
	{
		loop<SelectLoop>();

		if (quit)
		{
			quit=false;
			goto titletag;
		}

		switch (SelectLoop::selected)
		{
			case 0:
				loop<GameLoop <0> >();
				break;
			case 1:
				loop<GameLoop <1> >();
				break;
			case 2:
				loop<GameLoop <2> >();
				break;
			case 3:
				loop<GameLoop <3> >();
				break;
			case 4:
				loop<GameLoop <4> >();
				break;
			case 5:
				loop<GameLoop <5> >();
				break;
			case 6:
				loop<GameLoop <6> >();
				break;
			case 7:
				loop<GameLoop <7> >();
				break;
			case 8:
				loop<GameLoop <8> >();
				break;
			case 9:
				loop<GameLoop <9> >();
				break;
			case 10:
				loop<GameLoop <10> >();
				break;
			case 11:
				loop<GameLoop <11> >();
				break;
			case 12:
				loop<GameLoop <12> >();
				break;
			case 13:
				loop<GameLoop <13> >();
				break;
			case 14:
				loop<GameLoop <14> >();
				break;
			case 15:
				loop<GameLoop <15> >();
				break;
			case 16:
				loop<GameLoop <16> >();
				break;
			case 17:
				loop<GameLoop <17> >();
				break;
			case 18:
				loop<GameLoop <18> >();
				break;
			case 19:
				loop<GameLoop <19> >();
				break;
			case 20:
				loop<GameLoop <20> >();
				break;
			case 21:
				loop<GameLoop <21> >();
				break;
			case 22:
				loop<GameLoop <22> >();
				break;
			case 23:
				loop<GameLoop <23> >();
				break;
		}

		if (endmode)
		{
			showstory=true;
			goto storytag;
		}
	}
	}

	return 0;

}
END_OF_MAIN()
